package com.gzlh.bus.task;

import cn.hutool.extra.spring.SpringUtil;
import cn.hutool.http.HttpUtil;
import cn.hutool.json.JSONObject;
import cn.hutool.json.JSONUtil;
import com.gzlh.bus.ChannelCacheManager;
import com.gzlh.bus.EventBus;
import com.gzlh.bus.SysConfig;
import com.gzlh.config.ModuleEnum;
import com.gzlh.config.SystemObject;
import com.gzlh.device.led.utils.LedOptions;
import com.gzlh.device.plc.event.PLCEvent;
import lombok.extern.slf4j.Slf4j;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;

@Slf4j
@Component
public class CheckState {


    @Scheduled(cron = "0,25,40,55 * * * * ?")
    public void check() {
        String channelCode = SysConfig.channelSetting.getChannelCode();
        String api = SysConfig.managerSetting.getServerUrl() + "/open/channel/state?channelCode=" + channelCode;
        try {
            String resp = HttpUtil.get(api);
            JSONObject result = JSONUtil.parseObj(resp);
            Integer state = result.getInt("state");
            Integer cacheState = ChannelCacheManager.getStateMap(channelCode);
            ChannelCacheManager.setStateMap(channelCode, state);
            if (!state.equals(cacheState)) {
                handlerChannel(state);
            }
           // log.info("enable:{}",ChannelCacheManager.stateEnable(channelCode));
        } catch (Exception e) {
            log.error("resp:{}", e.getMessage());
        }

    }

    private void handlerChannel(Integer state) {
        if (state == 0) {
            EventBus eventBus = SpringUtil.getBean(EventBus.class);
            eventBus.startEvent(ModuleEnum.PLC_MODULE.getModuleEn() + "." + PLCEvent.IDLE);
        } else {
            EventBus eventBus = SpringUtil.getBean(EventBus.class);
            eventBus.startEvent(ModuleEnum.PLC_MODULE.getModuleEn() + "." + PLCEvent.SHUTDOWN);
        }
    }
}
