package com.gzlh.config.cache;

import cn.hutool.core.util.StrUtil;
import cn.hutool.extra.spring.SpringUtil;
import com.gzlh.bus.EventBus;
import com.gzlh.bus.EventDataManager;
import com.gzlh.config.ModuleEnum;
import com.gzlh.device.capture.event.CaptureEvent;
import com.gzlh.entity.ReqBO;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class CarCache {

    private final static List<CarDTO> STANDBY_LIST = new ArrayList<>();

    public static void handlerCarCache(String carNo, String httpUrl) {
        ReqBO reqBO = EventDataManager.getCacheData();
        if (reqBO == null || StrUtil.isEmpty(reqBO.getCarNo())) {
            EventDataManager.cacheData("carImg", httpUrl);
            EventDataManager.cacheData("carNo", carNo);
            EventDataManager.cacheData("gatherTime",new Date());
            return;
        }
        CarDTO carDTO = new CarDTO();
        carDTO.setCarImg(httpUrl).setCarNo(carNo);
        STANDBY_LIST.add(carDTO);
    }

    public static void setNextCar() {
        if (STANDBY_LIST.size() > 0) {
            CarDTO carDTO=  STANDBY_LIST.get(0);
            EventDataManager.cacheData("carImg", carDTO.getCarImg());
            EventDataManager.cacheData("carNo", carDTO.getCarNo());
            EventDataManager.cacheData("gatherTime", new Date());
            STANDBY_LIST.remove(0);
            EventBus eventBus= SpringUtil.getBean(EventBus.class);
            eventBus.startEvent(ModuleEnum.CAPTURE_MODULE.getModuleEn()+"."+ CaptureEvent.CAPTURE_ADMIN);
        }

        }
    }
