package com.gzlh.config.dto;

import com.fasterxml.jackson.annotation.JsonProperty;
import lombok.Data;
import lombok.NoArgsConstructor;
import lombok.experimental.Accessors;

import java.io.Serializable;
@Data
@Accessors(chain = true)
public class SerialSetting implements Serializable {
    @JsonProperty("host")
    private String host;
    @JsonProperty("weighbridge")
    private Weighbridge weighbridge;
    @JsonProperty("led")
    private LedDTO led;
    @JsonProperty("plc")
    private PlcDTO plc;

    @JsonProperty("electron")
    private ElectronSetting electron;

    @Data
    public static class ElectronSetting{
        private Boolean enable;
        private int port;
        private Integer brand;
    }

    @Data
    @NoArgsConstructor
    public static class Weighbridge{
        private Boolean enable;
        private int port;
        private Integer brand;
        private Integer minKg=1000;
    }
    @Data
    @NoArgsConstructor
    public static class LedDTO{
        private Boolean enable;
        private int port;
        private Integer brand;
    }
    @Data
    @NoArgsConstructor
    public static class PlcDTO{
        private Boolean enable;
        private int port;
        private Integer brand;
        private OutDTO out;
        private StatusDTO status;
        @Data
        @Accessors(chain = true)
        public static class OutDTO{
            private String signalRedPoint;
            private String signalGreenPoint;
            private String gatePoint;
        }
        @Data
        @Accessors(chain = true)
        public static class StatusDTO{
            /**
             * 上到位
             */
            private String upPoint;
            /**
             * 下到位
             */
            private String downPoint;
            /**
             * 雷达
             */
            private String radarPoint;
            /**
             * 前红外
             */
            private String fRedPoint;
            /**
             * 后红外
             */
            private String bRedPoint;
        }
    }



}
