package com.gzlh.config.hksdk.bo;

import cn.hutool.core.util.StrUtil;
import com.gzlh.config.ModuleEnum;
import lombok.Data;
import lombok.experimental.Accessors;

import java.util.List;
import java.util.Optional;
import java.util.concurrent.CopyOnWriteArrayList;

/**
 * 因为可能会有多个海康设备
 */
public class HKCacheManager {


    private final static List<DeviceType>DEVICE_TYPES=new CopyOnWriteArrayList<>();

    /**
     * 添加
     * @param module 类型
     * @param userId 登录设备返回的userId
     */
    public static void add(ModuleEnum module,int userId){
       Optional<DeviceType>deviceTypeOptional= DEVICE_TYPES.stream()
               .filter(deviceType -> StrUtil.equals(deviceType.getModule(), module.getModuleEn()))
                .findAny();
        if (deviceTypeOptional.isPresent()) {
            deviceTypeOptional.get().setUserId(userId);
        }else {
            DeviceType deviceType=new DeviceType();
            deviceType.setUserId(userId).setModule(module.getModuleEn());
            DEVICE_TYPES.add(deviceType);
        }
    }

    public static int getUserId(ModuleEnum module){
        Optional<DeviceType>deviceTypeOptional= DEVICE_TYPES.stream()
                .filter(deviceType -> StrUtil.equals(module.getModuleEn(), deviceType.module))
                .findAny();
        return deviceTypeOptional.map(DeviceType::getUserId).orElse(-1);
    }

    @Data
    @Accessors(chain = true)
    static class DeviceType{
        private String module;
        private int userId;
    }
}
