package com.gzlh.device.camera.controller;

import cn.hutool.cache.CacheUtil;
import cn.hutool.cache.impl.TimedCache;
import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.StrUtil;
import cn.hutool.core.util.XmlUtil;
import cn.hutool.log.StaticLog;
import com.gzlh.bus.EventDataManager;
import com.gzlh.bus.SysConfig;
import com.gzlh.config.SystemObject;
import com.gzlh.device.led.utils.LedOptions;
import com.gzlh.entity.ReqBO;
import com.gzlh.utils.FileUtils;
import com.gzlh.utils.ResultJson;
import lombok.extern.slf4j.Slf4j;
import org.springframework.boot.autoconfigure.web.ServerProperties;
import org.springframework.http.MediaType;
import org.springframework.util.StringUtils;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

import javax.annotation.Resource;
import java.io.IOException;
import java.net.InetAddress;
import java.net.URLDecoder;
import java.net.URLEncoder;
import java.util.*;
import java.util.stream.Collectors;


@RestController
@RequestMapping("/camera")
@Slf4j
public class CameraController {

    private final TimedCache<String,Integer> XML_CACHE= CacheUtil.newTimedCache(3000);

    @PostMapping(value = "/recv", produces = MediaType.TEXT_XML_VALUE)
    public String recv(
            @RequestBody String xmlStr
//            HttpServletRequest request
    )  {
        try {
            xmlStr = URLDecoder.decode(xmlStr);
            if (XML_CACHE.get(xmlStr,false)!=null){
                return "ok";
            }
            XML_CACHE.put(xmlStr,1);
            StaticLog.info("xml:{}", xmlStr);
            Map<String, Object> StringObjectMap = new HashMap<>();
            XmlUtil.xmlToMap(xmlStr, StringObjectMap);
            Map<String, Object> ic = BeanUtil.beanToMap(StringObjectMap.get("IC"));
            Map<String, Object> weight = BeanUtil.beanToMap(StringObjectMap.get("WEIGHT"));
            Map<String, Object> car = BeanUtil.beanToMap(StringObjectMap.get("CAR"));
            Map<String, Object> conta = BeanUtil.beanToMap(StringObjectMap.get("CONTA"));
            Map<String, Object> seal = BeanUtil.beanToMap(StringObjectMap.get("SEAL"));
            ReqBO.Box box = new ReqBO.Box();

            if (!StringUtils.isEmpty((String) conta.get("CONTA_NUM"))) {
                box.setBoxNum((String) conta.get("CONTA_NUM"));
            }
            Object CONTA_ID_F=conta.get("CONTA_ID_F");
            Object CONTA_ID_B=conta.get("CONTA_ID_B");
            if ((CONTA_ID_F==null||StrUtil.isEmpty(CONTA_ID_F.toString()))
                    &&(CONTA_ID_B==null||StrUtil.isEmpty(CONTA_ID_B.toString()))){
                log.error("-----empty no--------------");
                return "ok";
            }
            if (!StringUtils.isEmpty((String) CONTA_ID_F)) {
                box.setBoxF(CONTA_ID_F.toString());
            }
            if (!StringUtils.isEmpty((String) conta.get("CONTA_ID_B"))) {
                box.setBoxB((String) conta.get("CONTA_ID_B"));
            }
            if (!StringUtils.isEmpty((String) conta.get("CONTA_MODEL_F"))) {
                box.setModelF((String) conta.get("CONTA_MODEL_F"));
            }
            if (!StringUtils.isEmpty((String) conta.get("CONTA_MODEL_B"))) {
                box.setModelB((String) conta.get("CONTA_MODEL_B"));
            }
            List<String> fImgList = new ArrayList<>();
            List<String> bImgList = new ArrayList<>();
            String bPic = conta.get("CONTA_B_PIC")!=null?conta.get("CONTA_B_PIC").toString():"";
            String bLPic = conta.get("CONTA_BL_PIC")!=null?conta.get("CONTA_BL_PIC").toString():"";
            String bRPic = conta.get("CONTA_BR_PIC")!=null?conta.get("CONTA_BR_PIC").toString():"";
            bImgList.add(bPic);
            bImgList.add(bLPic);
            bImgList.add(bRPic);
            String fPic = conta.get("CONTA_F_PIC")!=null? conta.get("CONTA_F_PIC").toString():"";
            String fLPic =conta.get("CONTA_FL_PIC")!=null? conta.get("CONTA_FL_PIC").toString():"";
            String fRPic =conta.get("CONTA_FR_PIC")!=null? conta.get("CONTA_FR_PIC").toString():"";

            fImgList.add(fPic);
            fImgList.add(fLPic);
            fImgList.add(fRPic);
            String fBoxImg = fImgList.stream().filter(StrUtil::isNotEmpty).collect(Collectors.joining(","));
            box.setBoxFImg(fBoxImg);
            String bBoxImg = bImgList.stream().filter(StrUtil::isNotEmpty).collect(Collectors.joining(","));
            box.setBoxBImg(bBoxImg);
            EventDataManager.cacheData("box", box);
        }catch (Exception e){
            log.error("箱号识别处理异常:{}",e.getMessage());
            LedOptions options = new LedOptions().setLine("03").setColor("04").setShowType("0B");
            SystemObject.ledFactory.handler(SysConfig.serialSetting.getLed().getBrand())
                    .sendMsg("箱号识别异常", options.setLine("04").setColor("01"));
        }
        return "ok";
    }
}
