package com.gzlh.device.capture.handler.impl;

import cn.hutool.core.util.StrUtil;
import cn.hutool.json.JSONUtil;
import com.gzlh.device.capture.action.ICaptureAction;
import com.gzlh.device.capture.brand.CaptureBrandType;
import com.gzlh.device.capture.handler.ICaptureHandler;
import com.gzlh.entity.ReqBO;
import com.gzlh.bus.EventDataManager;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Component;

/**
 * 海康车牌抓拍机处理类
 */
@Component
@Slf4j
public class CaptureHandlerHk implements ICaptureHandler {
    @Override
    public CaptureBrandType brandType() {
        return CaptureBrandType.HK_BRAND;
    }

    @Override
    public void handlerAction(String action) {
        if (StrUtil.equals(action, ICaptureAction.UPLOAD_CAR_NO)){
           ReqBO reqBO= EventDataManager.getCacheData();
            //upload file
            log.info("upload car info:{}", JSONUtil.toJsonStr(reqBO));
        }
    }

}
