package com.gzlh.device.electron.factory;



import com.gzlh.device.capture.handler.ICaptureHandler;
import com.gzlh.device.electron.handler.IElectronHandler;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class ElectronFactory {
    @Autowired
    private List<IElectronHandler>handlers;

    public IElectronHandler handler(int code){
       return handlers.stream().filter(h->h.brandType().getCode()==code)
                .findAny().orElseThrow(()->new IllegalArgumentException("不支持电子车牌"));
    }

}
