package com.gzlh.device.led.client;

import com.gzlh.config.ModuleEnum;
import com.gzlh.utils.DeviceCache;
import io.netty.channel.ChannelHandler;
import io.netty.channel.ChannelHandlerContext;
import io.netty.channel.SimpleChannelInboundHandler;
import lombok.extern.slf4j.Slf4j;

@Slf4j
@ChannelHandler.Sharable
public class LedClientHandler extends SimpleChannelInboundHandler<String> {

    private LedNettyConfig ledNettyConfig;

    public LedClientHandler(LedNettyConfig ledNettyConfig) {
        this.ledNettyConfig = ledNettyConfig;
    }

    @Override
    protected void channelRead0(ChannelHandlerContext ctx, String msg) throws Exception {
        DeviceCache.changeDeviceStatus(ModuleEnum.LED_MODULE.getModuleZh(),1);
    }

    @Override
    public void channelInactive(ChannelHandlerContext ctx) throws Exception {
        log.error("led 客户端 连接断开，进行重连");
        DeviceCache.changeDeviceStatus(ModuleEnum.LED_MODULE.getModuleZh(),0);
        ledNettyConfig.connect();
    }

    @Override
    public void exceptionCaught(ChannelHandlerContext ctx, Throwable cause) throws Exception {
        log.error("led error:{}",cause.getMessage());
    }

}

