package com.gzlh.device.led.factory;



import com.gzlh.device.led.handler.ILedHandler;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class LedFactory {
    @Autowired
    private List<ILedHandler>handlers;

    public ILedHandler handler(int code){
       return handlers.stream().filter(h->h.brandType().getCode()==code)
                .findAny().orElseThrow(()->new IllegalArgumentException("不支持交互"));
    }

}
