package com.gzlh.entity;

import cn.hutool.json.JSONUtil;
import lombok.Data;
import lombok.NoArgsConstructor;
import lombok.experimental.Accessors;
import org.springframework.context.annotation.Lazy;

import java.io.Serializable;
import java.util.*;

@Data
@Accessors(chain = true)
public class ReqBO implements Serializable {
    /**
     * 方向 0=未知,1=进,2=退,3=离开
     */
    private int direction=0;
    /**
     * 通道号
     */
    private String channelCode="";;
    /**
     * 电子车牌 ERI
     */
    private String eri="";;
    /**
     * 车牌
     */
    private String carNo="";;
    /**
     * 车牌图片base64
     */
    private String carImg="";;
    /**
     * 称重重量kg
     */
    private Double weight;

    /**
     * 箱数据
     */
    private Box box;

    /**
     * 采集时间
     */
    private Date gatherTime;

    @Data
    public static class Box {
        /**
         * 前箱号
         */
        private String boxF="";
        /**
         * 后箱号
         */
        private String boxB="";
        /**
         * 后箱号图片多张,号分割
         */
        private String boxBImg="";
        /**
         * 后箱号图片 多张,号分割
         */
        private String boxFImg="";
        /**
         * 前箱型
         */
        private String modelF="";
        /**
         * 后箱型
         */
        private String modelB="";
        /**
         * 箱数量
         */
        private String boxNum="";
    }

    public static void main(String[] args) {
        ReqBO reqBO=new ReqBO();
        reqBO.setBox(new Box());
        String str=JSONUtil.toJsonStr(reqBO);
        System.out.println(str);
    }

}
