package com.gzlh.hx.callback;

import cn.hutool.core.date.DateUtil;
import cn.hutool.core.io.FileUtil;
import cn.hutool.core.util.RandomUtil;
import cn.hutool.extra.spring.SpringUtil;
import com.gzlh.bus.SysConfig;
import com.gzlh.config.dto.ChannelSetting;
import com.gzlh.config.task.TaskService;
import com.gzlh.device.capture.task.HandlerCarImage;
import com.gzlh.hx.jepgshow.jpegShow;
import com.sun.jna.Pointer;
import lombok.extern.slf4j.Slf4j;

import java.io.DataOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.text.SimpleDateFormat;
import java.time.LocalDate;
import java.util.Date;

@Slf4j
public class PlateCallback implements IPlateCallback {
    @Override
    public void ICE_IPCSDK_Plate(int param, String strIP, String strNumber, String strColor,
                                 Pointer pPicData, int nLen, Pointer pCloseupData, int nCloseupLen, int nReserved1,
                                 int nVehicleType, int nFalsePlate, int nReserved2, float fPlateConfidence,
                                 int nVehicleColor, int nPlateType, int nVehicleDir, int nAlarmType,
                                 int nSerialNum, int nCapTime, int nReserved3, int nReserved4) {
        log.info("ICE_IPCSDK_Plate:{}:{}:{},{}", param, strIP, strColor, strNumber);

        if (nLen > 0) {
            byte[] dst = new byte[nLen];
            pPicData.read(0, dst, 0, nLen);
            savePic(strIP, strNumber, dst, 0, 0);
        }
    }

    public static void savePic(String strIP, String strNumber, byte[] data, int type, long lTime) {

        Date nowTime = null;
        if (lTime == 0)
            nowTime = new Date();
        else
            nowTime = new Date(lTime);
        String separator=File.separator;
        String newName = DateUtil.format(nowTime, "yyMMddHHmm");
        String fileName = strNumber + "-" + newName + ".jpg";
        LocalDate now=LocalDate.now();
        ChannelSetting channelSetting= SysConfig.channelSetting;
        String fileFolder=channelSetting.getChannelCode()+separator+now.getYear()+separator+now.getMonthValue()+separator+now.getDayOfMonth();
        FileUtil.mkdir(channelSetting.getFileRootPath()+separator+fileFolder);
        String filePath=fileFolder +separator+ fileName;
        String savedFilePath=channelSetting.getFileRootPath()+separator+filePath;
        try {
            DataOutputStream out = new DataOutputStream(Files.newOutputStream(Paths.get(savedFilePath)));
            TaskService taskService = SpringUtil.getBean(TaskService.class);
            String httpUrl = "http://" + channelSetting.getIp() + "/" + filePath.replace("\\", "/");
            taskService.addTask(new HandlerCarImage(RandomUtil.randomNumbers(10), 1, httpUrl, strNumber));
            out.write(data);
            out.close();
        } catch (IOException e1) {
            // TODO Auto-generated catch block
            e1.printStackTrace();
        }
    }
}
