package com.gzlh.hx.handler;

import cn.hutool.core.util.StrUtil;
import com.gzlh.bus.SysConfig;
import com.gzlh.config.dto.CaputreSetting;
import com.gzlh.hx.api.IceSdk;
import com.gzlh.hx.callback.DeviceEventCallback;
import com.gzlh.hx.callback.PlateCallback;
import com.sun.jna.Pointer;
import lombok.extern.slf4j.Slf4j;

@Slf4j
public class InitHxSDK implements Runnable {


    @Override
    public void run() {
        CaputreSetting caputreSetting = SysConfig.caputreSetting;
        String ip = caputreSetting.getHost();
        IceSdk.jnaLib.ICE_IPCSDK_Init();
        PlateCallback plateCallback = new PlateCallback();
        Pointer pointer = IceSdk.jnaLib.ICE_IPCSDK_OpenDevice(caputreSetting.getHost());
        if (pointer==null){
            log.error("connect 华夏智信相机异常:{}",ip);
            return;
        }
        IceSdk.jnaLib.ICE_IPCSDK_EnableUTF8(pointer,1);
        int param = Integer.parseInt(StrUtil.subAfter(ip, ".", true));
        IceSdk.jnaLib.ICE_IPCSDK_SetPlateCallback(pointer, plateCallback, param);
        IceSdk.jnaLib.ICE_IPCSDK_SetDeviceEventCallBack(pointer, new DeviceEventCallback(), pointer);

    }
}
