package com.gzlh.utils;

public class ModbusUtils {
    public static String buildRequestPacket(String packData) {
        int[] a = new int[packData.length() / 2];
        for (int i = 0; i < packData.length(); i += 2) {
            a[i / 2] = Integer.parseInt(packData.substring(i, i + 2), 16);
        }
        int crc = calculateCRC(a);
       return packData+String.format("%04X",crc);
    }
    private static int swapBytes(int value) {
        int highByte = (value >> 8) & 0xFF; // 获取高字节
        int lowByte = value & 0xFF; // 获取低字节

        return (lowByte << 8) | highByte; // 交换高低字节位置
    }
    public static int calculateCRC(int[] data) {
        int crc = 0xFFFF;

        for (int b : data) {
            crc ^= (int) b & 0xFF;
            for (int i = 0; i < 8; i++) {
                if ((crc & 0x0001) != 0) {
                    crc >>= 1;
                    crc ^= 0xA001;
                } else {
                    crc >>= 1;
                }
            }
        }

        return swapBytes(crc);
    }


}
