package com.gzlh.utils;

import cn.hutool.core.util.CharsetUtil;
import cn.hutool.core.util.StrUtil;
import com.gzlh.device.led.utils.ColorConver;
import com.gzlh.device.led.utils.YangBandPackage;

import javax.crypto.BadPaddingException;
import javax.crypto.Cipher;
import javax.crypto.IllegalBlockSizeException;
import javax.crypto.NoSuchPaddingException;
import javax.crypto.spec.SecretKeySpec;
import javax.xml.bind.DatatypeConverter;
import java.math.BigDecimal;
import java.math.RoundingMode;
import java.nio.charset.Charset;
import java.security.InvalidKeyException;
import java.security.NoSuchAlgorithmException;
import java.util.Arrays;

public class WordHandlerUtils {

    static String key ="SC35fdGrQofSMT5a";

    public static String msgToASCII(String msg){
        int len=msg.length();
        StringBuilder sb=new StringBuilder();
        for (int i=0;i<len;i++){
            char ch=msg.charAt(i);
            String bit =ch+"";
            if (isChinese(ch)){//中文
                sb.append(chineseToASCII(bit));
            }else if (Character.isDigit(ch)){//数字
                sb.append(Integer.parseInt(bit) + 30);
            }else if (StrUtil.equals(".", bit)) {
                sb.append("2E");
            }else if (Character.isLetter(ch)){
                sb.append(Integer.toHexString(ch));
            }else if (StrUtil.contains(ch+""," ")){
                sb.append("20");
            }
        }
        return sb.toString();
    }




    /**
     * 中文转ascii
     * @param zh
     * @return
     */
    private static String chineseToASCII(String zh) {
        byte[] gb2312Bytes = zh.getBytes(Charset.forName("GB2312"));
        return bytesToHexString(gb2312Bytes);
    }

    /**
     * 红色字体在文字前加代码 5C 43 31，绿色加代码5C 43 32，黄色加代码5C 43 33
     *
     * @param weight
     * @return
     */
    private static String numToASCII(int weight) {
        String str = BigDecimal.valueOf(weight).divide(BigDecimal.valueOf(1000), 2, RoundingMode.HALF_UP).toString();
        int len = str.length();
        StringBuilder sb = new StringBuilder();
        for (int i = 0; i < len - 1; i++) {
            String bit = StrUtil.sub(str, i, i + 1);
            if (StrUtil.equals(".", bit)) {
                sb.append("2E").append(" ");
                continue;
            }
            sb.append(Integer.parseInt(bit) + 30).append(" ");
        }
        return  sb.toString();
    }

    private static boolean isChinese(char ch) {
        Character.UnicodeBlock ub = Character.UnicodeBlock.of(ch);
        if (ub == Character.UnicodeBlock.CJK_UNIFIED_IDEOGRAPHS
                || ub == Character.UnicodeBlock.CJK_COMPATIBILITY_IDEOGRAPHS
                || ub == Character.UnicodeBlock.CJK_UNIFIED_IDEOGRAPHS_EXTENSION_A
                || ub == Character.UnicodeBlock.CJK_UNIFIED_IDEOGRAPHS_EXTENSION_B
                || ub == Character.UnicodeBlock.CJK_SYMBOLS_AND_PUNCTUATION
                || ub == Character.UnicodeBlock.HALFWIDTH_AND_FULLWIDTH_FORMS
                || ub == Character.UnicodeBlock.GENERAL_PUNCTUATION) {
            return true;
        }
        return false;
    }


    private static String bytesToHexString(byte[] bytes) {
        StringBuilder sb = new StringBuilder();
        for (byte b : bytes) {
            String hex = Integer.toHexString(b & 0xFF);
            if (hex.length() == 1) {
                sb.append('0');
            }
            sb.append(hex.toUpperCase());
        }
        return sb.toString();
    }

    public static String AESEncrypt(String data)  {

        SecretKeySpec secretKey = new SecretKeySpec(key.getBytes(), "AES");

        Cipher cipher = null; // 选择AES算法、工作模式为ECB、填充方式为PKCS5Padding
        byte[] encryptedBytes =null;
        try {
            cipher = Cipher.getInstance("AES/ECB/PKCS5Padding");
            cipher.init(Cipher.ENCRYPT_MODE, secretKey); // 初始化加密器
            encryptedBytes = cipher.doFinal(data.getBytes()); // 对明文进行加密操作
        } catch (NoSuchAlgorithmException | NoSuchPaddingException | BadPaddingException
                | IllegalBlockSizeException | InvalidKeyException e) {
            e.printStackTrace();
        }

//        System.out.println("Encrypted Text: " + DatatypeConverter.printHexBinary(encryptedBytes));
        return DatatypeConverter.printHexBinary(encryptedBytes);
    }

    public static String AESDecrypt(String data)  {
        byte[] result = new byte[data.length()/2];
        for (int i = 0; i < data.length()/2; i++) {
            result[i] =Integer.valueOf(data.substring(i * 2, i * 2 + 2), 16).byteValue();
        }

        SecretKeySpec secretKey = new SecretKeySpec(key.getBytes(), "AES");

        Cipher cipher = null; // 选择AES算法、工作模式为ECB、填充方式为PKCS5Padding
        byte[] decryptedBytes = null;
        String decryptStr =null;
        try {
            cipher = Cipher.getInstance("AES/ECB/PKCS5Padding");
            cipher.init(Cipher.DECRYPT_MODE, secretKey); // 初始化解密器
            decryptedBytes = cipher.doFinal(result); // 对密文进行解密操作
//            System.out.println("Decrypted Text: " + new String(decryptedBytes));
            decryptStr=new String(decryptedBytes);
        } catch (NoSuchAlgorithmException | NoSuchPaddingException | BadPaddingException
                | IllegalBlockSizeException | InvalidKeyException e) {
            e.printStackTrace();
        }
        return decryptStr;
    }

}

